
#include "wxVideoGUI.h"

//wxDEFINE_EVENT(wxEVT_COMMAND_MYTHREAD_UPDATE, wxThreadEvent)
//DEFINE_EVENT_TYPE(wxID_HIDE1)
//DEFINE_EVENT_TYPE(wxID_HIDE2)
//DEFINE_EVENT_TYPE(wxID_HIDE3)
//DEFINE_EVENT_TYPE(wxID_DETECT)
//DEFINE_EVENT_TYPE(wxID_SAVE)
//DEFINE_EVENT_TYPE(EVT_MOTION)
DEFINE_EVENT_TYPE(wxEVT_COMMAND_THREAD_UPDATE)
DEFINE_EVENT_TYPE(wxEVT_COMMAND_SLIDER_UPDATE)
DEFINE_EVENT_TYPE(wxID_MOUSELOC)
DEFINE_EVENT_TYPE(wxID_REPEAT)
DEFINE_EVENT_TYPE(wxID_SEEPOINTS)
DEFINE_EVENT_TYPE(wxID_OPENFRAMES)
DEFINE_EVENT_TYPE(wxID_LISTA)
DEFINE_EVENT_TYPE(wxID_LOAD)
//DEFINE_EVENT_TYPE(wxID_LOADPLOT)
DEFINE_EVENT_TYPE(wxID_SCREENSHOT)
DEFINE_EVENT_TYPE(wxID_EXCEL)
DEFINE_EVENT_TYPE(wxID_CSV)

BEGIN_EVENT_TABLE(MainFrame, wxFrame)
	EVT_COMMAND  (wxID_ANY, wxEVT_COMMAND_THREAD_UPDATE, MainFrame::OnThreadUpdate)
	EVT_COMMAND  (wxID_ANY, wxEVT_COMMAND_SLIDER_UPDATE, MainFrame::OnSliderAutoUpdate)
	EVT_COMMAND (wxID_BTN1, wxEVT_COMMAND_BUTTON_CLICKED, MainFrame::m_button1OnButtonClick)
	EVT_COMMAND (wxID_BTN2, wxEVT_COMMAND_BUTTON_CLICKED, MainFrame::m_button2OnButtonClick)
	EVT_COMMAND (wxID_ANY, wxEVT_COMMAND_LISTBOX_SELECTED, MainFrame::m_listBox1OnListBox)
	EVT_SCROLL_THUMBRELEASE  (MainFrame::OnSliderUpdate)
	EVT_SCROLL_CHANGED  (MainFrame::OnSliderChanged)
	EVT_SCROLL_THUMBTRACK  (MainFrame::OnSliderGrab)
    EVT_MENU(wxID_EXIT,  MainFrame::OnExit)
    EVT_MENU(wxID_OPEN, MainFrame::OnOpen)
    EVT_MENU(wxID_OPENFRAMES, MainFrame::OnOpenFromFrames)
    EVT_MENU(wxID_SAVE, MainFrame::OnSavePoints)
    EVT_MENU(wxID_SCREENSHOT, MainFrame::OnSaveScreenshot)
    EVT_MENU(wxID_LOAD, MainFrame::OnLoadPoints)
   // EVT_MENU(wxID_LOADPLOT, MainFrame::OnLoadSingleGraph)
    EVT_MENU(wxID_EXCEL, MainFrame::OnExportsExcel)
    EVT_MENU(wxID_CSV, MainFrame::OnExportsCSV)
    EVT_MENU(wxID_ABOUT, MainFrame::OnAbout)
    EVT_MENU(wxID_SEEPOINTS, MainFrame::OnThreadUpdate)
    EVT_MENU(wxID_HIDE1, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE2, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE3, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE4, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE5, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE6, MainFrame::OnHiding)
    EVT_MENU(wxID_HIDE7, MainFrame::OnHiding)
    EVT_MENU(wxID_FPS, MainFrame::OnFPS )
    EVT_MENU(wxID_CAL1, MainFrame::OnCal1 )
    EVT_MENU(wxID_CAL2, MainFrame::OnCal2 )
    EVT_TOOL(wxID_DETECT, MainFrame::OnTools)
    EVT_TOOL(wxID_PLAY, MainFrame::OnTools )
    //EVT_TOOL(wxID_PAUSE, MainFrame::OnTools )
   	EVT_TOOL(wxID_NEXT, MainFrame::OnTools )
   	EVT_TOOL(wxID_PREV, MainFrame::OnTools )
   	EVT_TOOL(wxID_STOP, MainFrame::OnTools )
   	EVT_TOOL(wxID_INI, MainFrame::OnTools )
   	EVT_TOOL(wxID_CALC, MainFrame::OnTools )
   	EVT_TOOL(wxID_END, MainFrame::OnTools )
  	EVT_TOOL(wxID_ADDPTS, MainFrame::OnTools )
  	EVT_TOOL(wxID_RMVPTS, MainFrame::OnTools )
  	EVT_TOOL(wxID_VRDT, MainFrame::OnTools )
  	EVT_TOOL(wxID_DISTANCE, MainFrame::OnTools )
  	EVT_TOOL(wxID_REALDIST, MainFrame::OnTools )
  	EVT_TOOL(wxID_HOR, MainFrame::OnTools )
  	EVT_TOOL(wxID_3PTS, MainFrame::OnTools )
  	EVT_TOOL(wxID_2PTS, MainFrame::OnTools )
    EVT_SIZE(MainFrame::OnResize)
  	//EVT_SIZE(MainFrame::onSize)
// 	EVT_PAINT(MainFrame::OnPaintEvent)
//  	EVT_LEFT_UP(MainFrame::onMouseDown)
  	//EVT_MOTION(MainFrame::onMouseMove)
END_EVENT_TABLE()
